<?php
$plugins->add_hook('parse_message_start', 'coolcode_start');
// workaround for preparser mod
$plugins->add_hook('showthread_start', 'coolcode_add_header');
$plugins->add_hook('archive_start', 'coolcode_archive');

function coolcode_info()
{
	return array(
		'name'			=> 'Cool Codes',
		'description'	=> 'Syntax Highlighting plus better looking code box.',
		'website'		=> 'http://mybbhacks.zingaburga.com/',
		'author'		=> 'ZiNgA BuRgA',
		'authorsite'	=> 'http://zingaburga.com/',
		'version'		=> '1.26',
		'compatibility'	=> '14*,15*,16*,17*,18*'
	);
}

function coolcode_archive() {
	if($GLOBALS['action'] != 'thread') return;
	ob_start();
	function coolcode_archive_end() { ob_end_flush(); }
	$GLOBALS['plugins']->add_hook('archive_thread_end', 'coolcode_archive_end');
}

function &coolcode_start(&$msg) {
	global $parser;
	// try to obtain parser options
	$opts = array('allow_mycode' => 1, 'filter_badwords' => 1); // defaults if we can't retrieve options
	if(is_object($parser)) {
		$vercode =& $GLOBALS['mybb']->version_code;
		if($vercode >= 1500 && $vercode <= 1600) {
			$p = (array)$parser;
			$opts =& $p["\0postParser\0options"];
		} else
			$opts =& $parser->options;
	}
	if($opts['allow_mycode']) {
		$msg = str_replace("\x01", '', $msg);
		$regex = "#\[(c|cpp|vb|sql|bat|java|js|html|xml|php|ini|code)(=[0-9]+?)?\](.*?)\[/\\1\]\r?\n?#si";
		preg_match_all($regex, $msg, $GLOBALS['coolcode_matches'], PREG_SET_ORDER);
		$msg = preg_replace($regex, "\x01", $msg);
		
		// stick in parser stuff that we skip due to the placement of the hook
		foreach($GLOBALS['coolcode_matches'] as &$code) {
			$matchcode =& $code[3];
			$matchcode = str_replace("\r", '', $matchcode);
			if($opts['filter_badwords'] && is_object($parser)) {
				$matchcode = $parser->parse_badwords($matchcode);
			}
		}
		
		$GLOBALS['plugins']->add_hook('parse_message_end', 'coolcode_end');
	}
	return $msg;
}

function &coolcode_end(&$msg) {
	$GLOBALS['plugins']->remove_hook('parse_message_end', 'coolcode_end');
	coolcode_run($msg, $GLOBALS['coolcode_matches']);
	unset($GLOBALS['coolcode_matches']);
	
	coolcode_add_header();
	
	return $msg;
}

function coolcode_add_header() {
	static $header_added=false;
	if(!$header_added) {
		global $mybb;
		if(defined('IN_ARCHIVE')) {
			$GLOBALS['plugins']->remove_hook('archive_thread_end', 'ob_end_flush');
			$contents = ob_get_contents();
			ob_end_clean();
			echo str_replace('</head>', '<link rel="stylesheet" type="text/css" href="'.$mybb->settings['bburl'].'/cache/highlight.css" /></head>', $contents);
		}
		else {
			$GLOBALS['headerinclude'] .= '<script language="javascript" type="text/javascript" src="'.$mybb->settings['bburl'].'/jscripts/highlight.js"></script><link rel="stylesheet" type="text/css" href="'.$mybb->settings['bburl'].'/cache/highlight.css" />';
		}
		$header_added = true;
	}
}

function coolcode_run(&$message, &$coolcode_matches)
{
	if(empty($coolcode_matches)) return;
	global $lang;
	$langvars = array(
		'c' => 'C Code',
		'cpp' => 'C++ Code',
		'java' => 'Java Code',
		'js' => 'Javascript Code',
		'bat' => 'Batch Script',
		'sql' => 'SQL Code',
		'vb' => 'Visual Basic Code',
		'html' => 'HTML Code',
		'xml' => 'XML Code',
		'php' => $lang->php_code,
		'ini' => 'INI',
		'code' => $lang->code
	);
	require_once MYBB_ROOT.'inc/highlighter.php';
	$codes = array();
	foreach($coolcode_matches as $text)
	{
		$code = trim(strtr($text[3], array("\x00" => '', "\x01" => '')), "\n\r");
		$lines = substr_count($code, "\n");
		if(!isset($text[2]{1}))
			$start = 1;
		else
		{
			$start = intval(substr($text[2],1));
			if($start < 1) $start = 1;
		}
		
		$linecode = '';
		if(!defined('IN_ARCHIVE') && ($start != 1 || $lines >= 5)) { // note that lines is actually less one, so >=5 actually means > 5
			$linetext = implode("<br />", range($start, $start+$lines));
			$linecode = '<td><div class="linenum"><code>'.$linetext.'</code></div></td>';
		}
		
		$text[1] = strtolower($text[1]);
		if($text[1] != 'code')
		{
			$func = $text[1].'_highlight';
			
			// disallow use of our special characters
			$code .= "\n";
			$code = str_replace(get_placeholder(8), 'class', substr($func($code), 0, -1)); // add & strip extra newline
		}
		else
			$code = htmlspecialchars_uni($code);
		
		$select_button = '';
		if(!defined('IN_ARCHIVE') && THIS_SCRIPT != 'xmlhttp.php') {
			static $sel_id = 0;
			++$sel_id;
			$id = TIME_NOW.'_'.$sel_id.'_'.mt_rand(0, 100); // need to be more unique for quick reply
			$select_button = '<input type="button" class="button select_button" value="Select" onClick="selectObj(this.parentNode.parentNode.getElementsByTagName(\'pre\')[0].getElementsByTagName(\'code\')[0])" id="coolcode_btnsel_'.$id.'" style="display: none;" /><script type="text/javascript">
//<!--
document.getElementById("coolcode_btnsel_'.$id.'").style.display = "";
//-->
</script>';
		}
		
		// we use a TABLE to fix issues with Opera
		$codes[] = "</p>\n".'<div class="codeblock"><div class="title">'.$select_button.$langvars[$text[1]]."\n</div>".'
			<div class="codecontainer"><table><tr>'.$linecode.'<td>
			<pre><code>'.$code.'</code></pre></td></tr></table></div><hr class="hidden clear" /></div>'."\n<p>\n";
		//$message = preg_replace("#\x00#", $code, $message, 1);
	}
	$message = our_str_replace("\x01", $codes, $message);
}

?>